#version 450
#extension GL_ARB_separate_shader_objects : enable

struct shader_input_0
{
	float2 position : POSITION0;
	float2 texcoord : TEXCOORD0;
	uint colour : COLOUR0;
};

struct shader_output_0
{
	float4 position : POSITION0;
	float2 texcoord : TEXCOORD0;
	float4 colour : COLOUR0;
};

layout(push_constant) uniform PushConstants 
{ 
    vec2 uScale;
    vec2 uTranslate;
} pc;

void main()
{
	uint col = shader_input_0.colour;
	shader_output_0.colour.r = float(0xff & (col >> 0)) / 255.0;
	shader_output_0.colour.g = float(0xff & (col >> 8)) / 255.0;
	shader_output_0.colour.b = float(0xff & (col >> 16)) / 255.0;
	shader_output_0.colour.a = float(0xff & (col >> 24)) / 255.0;
    shader_output_0.texcoord = shader_input_0.texcoord;
    shader_output_0.position = vec4(shader_input_0.position * pc.uScale + pc.uTranslate, 0.0, 1.0);
}