-- premake5.lua
newoption {
	trigger		= "platform",
	value		= "Platform",
	description	= "Build Platform",
	allowed = {
		{ "win32", 	"Win32" },
		{ "osx",	"OSX" }
	}
}

newoption {
	trigger		= "gfxapi",
	value		= "API",
	description	= "Graphics API",
	allowed	= {
		{ "opengl",		"OpenGL" },
		{ "vulkan",		"Vulkan" }
	}
}

function setup_options()
    platform = nil
    if _OPTIONS["platform"] then
        platform = _OPTIONS["platform"]
    end
    
    gfxapi = nil
    if _OPTIONS["gfxapi"] then
        gfxapi = _OPTIONS["gfxapi"]
    end
end

function setup_platform()

    includedirs
    {
        "third_party/stb",
        "third_party/glm",
        "third_party/rapidjson/include",
        "third_party/imgui"
    }

-- platform specific source files    
    if(platform == "win32") then
        includedirs
        {
            "include/win32"
        }
        
        files
        { 
            "include/win32/*.h",
            "source/win32/*.cpp",
        }
        systemversion "latest"
        characterset "MBCS"
    end
    
-- graphics api specific source files    
    if(gfxapi == "opengl") then
        includedirs
        {
            "third_party/glew/include"
        }
		
        files 
        { 
            "source/opengl/*.cpp",
            "third_party/glew/source/*.c"
        }
        
        defines
        {
            "GLEW_STATIC"
        }
    end
    
    if(gfxapi == "vulkan") then
        includedirs
        {
            "third_party/vulkansdk/Include"
        }
		files { "source/vulkan/*.cpp" }
    end
    
end

function setup_links()
    
    if(gfxapi == "vulkan") then
        libdirs
        {
            "../../QuickGFX/third_party/vulkansdk/Lib"
        }
        
        links
        {
            "vulkan-1.lib"
        }    
    end
    
    if(gfxapi == "opengl") then
        links
        {
            "OpenGL32.lib"
        }
    end
	
	links
	{
		"dsound.lib"
	}
end